'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Index = function (_Component) {
  _inherits(Index, _Component);

  function Index(props) {
    _classCallCheck(this, Index);

    var _this = _possibleConstructorReturn(this, (Index.__proto__ || Object.getPrototypeOf(Index)).call(this, props));

    _this.moveInterval = null;
    _this.state = {
      items: [],
      activeIndex: props.activeIndex
    };
    _this.transitionEnd = _this.transitionEnd.bind(_this);
    return _this;
  }

  _createClass(Index, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var children = this.props.children;

      var newItems = this.newCreateData(children);
      this.setState({
        items: newItems
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.parseItems(this.props);
      this.startAutoPlay(this.props);
      _utils.events.on(this.swipeItems, 'webkitTransitionEnd', this.transitionEnd);
      _utils.events.on(this.swipeItems, 'transitionend', this.transitionEnd);
      this.doTransition(this.props.activeIndex, this.props.speed);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      console.log('this.props', this.props.children);
      console.log('nextProps', nextProps.children);
      if ('children' in nextProps) {
        this.pauseAutoPlay();
        this.parseItems(nextProps);
        this.startAutoPlay(nextProps);
        this.doTransition(nextProps.activeIndex, 0);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // 自动轮播结束
      console.log('结束');
      this.pauseAutoPlay();
      // 移除监听窗口变化
      _utils.events.off(this.swipeItems, 'webkitTransitionEnd', this.transitionEnd);
      _utils.events.off(this.swipeItems, 'transitionend', this.transitionEnd);
    }
  }, {
    key: 'pauseAutoPlay',
    value: function pauseAutoPlay() {
      if (this.moveInterval) {
        clearInterval(this.moveInterval);
      }
    }
  }, {
    key: 'transitionEnd',
    value: function transitionEnd() {
      var len = this.props.children.length ? this.props.children.length : 1;
      if (this.state.activeIndex === len) {
        this.doTransition(0, 0);
      }
    }
  }, {
    key: 'startAutoPlay',
    value: function startAutoPlay(props) {
      var _this2 = this;

      var obj = this.swipeItems.children[0];
      var child = props.children;
      var value = props.direction === 'vertical' ? obj.offsetHeight : obj.offsetWidth;
      var parent = this.swipeItems.parentNode;
      var wrapVal = props.direction === 'vertical' ? parent.offsetHeight : parent.offsetWidth;
      var len = child.length ? child.length : 1;
      if (child.length === 0 || wrapVal > len * value) {
        return;
      }
      this.moveInterval = setInterval(function () {
        var newLocal = _this2.state.activeIndex;
        var activeIndex = newLocal;
        var maxLength = props.children.length ? props.children.length : 1; // 解决存在一个子元素的问题
        var dom = _this2.swipeItems;
        activeIndex += 1;
        if (props.continuous) {
          var val = props.direction === 'vertical' ? dom.children[0].offsetHeight : dom.children[0].offsetWidth;

          if (-activeIndex <= -maxLength * val) {
            activeIndex = 0;
          }

          _this2.doTransition(activeIndex, 0);
        } else {
          if (activeIndex > maxLength) {
            activeIndex = 0;
          }

          _this2.doTransition(activeIndex, props.speed);
        }
      }, props.continuous ? 30 : this.props.timer);
    }
    // 是否复制

  }, {
    key: 'parseItems',
    value: function parseItems(props) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};

      var items = [];
      var obj = this.swipeItems.children[0];
      var child = props.children;
      var val = props.direction === 'vertical' ? obj.offsetHeight : obj.offsetWidth;
      var parent = this.swipeItems.parentNode;
      var wrapVal = props.direction === 'vertical' ? parent.offsetHeight : parent.offsetWidth;
      var len = child.length ? child.length : 1;
      if (child.length === 0) {
        return;
      }
      if (wrapVal < len * val) {
        items = [].concat(child, child);
      } else {
        items = [].concat(child);
      }
      var newItems = this.newCreateData(items);

      this.setState({
        items: newItems
      }, callback);
    }
    // 创建子元素

  }, {
    key: 'newCreateData',
    value: function newCreateData(items) {
      var props = this.props;

      return _react.Children.map(items, function (element, index) {
        var _classnames;

        return (0, _react.cloneElement)(element, {
          key: index,
          className: (0, _classnames4.default)((_classnames = {}, _defineProperty(_classnames, props.prefixCls + '-' + props.direction + '-item', true), _defineProperty(_classnames, element.props.className, !!element.props.className), _classnames))
        });
      });
    }
  }, {
    key: 'doTransition',
    value: function doTransition(index, duration) {
      var dom = this.swipeItems;
      var domChild = dom.children[index];
      var y = 0;
      var x = 0;
      if (this.props.direction === 'vertical') {
        y = this.props.continuous ? -index : -index * domChild.offsetHeight;
      } else if (this.props.direction === 'landscape') {
        x = this.props.continuous ? -index : -index * domChild.offsetWidth;
      }

      dom.style.webkitTransitionDuration = duration + 'ms';
      dom.style.transitionDuration = duration + 'ms';
      dom.style.webkitTransform = 'translate3d(' + x + 'px, ' + y + 'px, 0)';
      dom.style.transform = 'translate3d(' + x + 'px, ' + y + 'px, 0)';
      this.setState({
        activeIndex: index
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames2,
          _this3 = this;

      var _props = this.props,
          className = _props.className,
          direction = _props.direction;
      var prefixCls = this.props.prefixCls;


      prefixCls = prefixCls + '-' + direction;

      var classes = (0, _classnames4.default)((_classnames2 = {}, _defineProperty(_classnames2, '' + prefixCls, true), _defineProperty(_classnames2, className, !!className), _classnames2));
      return _react2.default.createElement(
        'div',
        { className: classes },
        _react2.default.createElement(
          'div',
          {
            className: prefixCls + '-wrap',
            ref: function ref(ele) {
              _this3.swipeItems = ele;
            }
          },
          this.state.items
        )
      );
    }
  }]);

  return Index;
}(_react.Component);

Index.propTypes = {
  prefixCls: _propTypes2.default.string,
  className: _propTypes2.default.string,
  speed: _propTypes2.default.number,
  activeIndex: _propTypes2.default.number,
  continuous: _propTypes2.default.bool,
  timer: _propTypes2.default.number,
  direction: _propTypes2.default.string,
  children: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array])
};

Index.defaultProps = {
  prefixCls: 'iyb-marquee',
  className: '',
  speed: 300, // 动画完成时间
  activeIndex: 0, // 位置
  continuous: false, // 连续滚动还是间接滚动 默认间接滚动false
  timer: 2000, // continuous为flase才生效
  direction: 'vertical', // 方向 是垂直还是横向.vertical landscape
  children: []
};

exports.default = Index;